%define debug_package %{nil}

Name:           ddrescue
Version:        1.19
Release:        2%{?dist}
Summary:        Data recovery tool trying hard to rescue data in case of read errors
Group:          Applications/System
License:        GPLv2+
Packager:	Lawrence R. Rogers (lrr@cert.org)
URL:            http://www.gnu.org/software/ddrescue/ddrescue.html
%if 0%{?rhel} == 5
Source0:        http://ftp.gnu.org/gnu/ddrescue/ddrescue-%{version}.tar.gz
%else
Source0:        http://ftp.gnu.org/gnu/ddrescue/ddrescue-%{version}.tar.lz
BuildRequires:	lzip
%endif
Patch0:         %{name}-%{version}-testsuite.patch
#Patch1:		%{name}-%{version}-patch-001
# Patch correct location of binary to run tests
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(post): info
Requires(preun): info

%description
GNU ddrescue is a data recovery tool. It copies data from one file or block
device (hard disc, cd-rom, etc) to another, trying hard to rescue data in 
case of read errors. GNU ddrescue does not truncate the output file if not
asked to. So, every time you run it on the same output file, it tries to 
fill in the gaps.

%prep
%setup
%patch0 -p1 -b .test

%build
# not a real autotools configure script, flags need to be passed specially
%configure CFLAGS="%{optflags}" CXXFLAGS="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
rm -f %{buildroot}%{_infodir}/dir

%clean
rm -rf %{buildroot}

%check
cd testsuite
sh -x check.sh

%post
/sbin/install-info %{_infodir}/%{name}.info %{_infodir}/dir || :

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_infodir}/%{name}.info %{_infodir}/dir || :
fi

%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING NEWS README
%{_bindir}/ddrescue
%{_mandir}/man1/ddrescue.1*
%{_bindir}/ddrescuelog
%{_mandir}/man1/ddrescuelog.1*
%{_infodir}/%{name}.info*

%changelog
* Fri Oct  3 2014 Lawrence Rogers <lrr@cert.org> 1.19-1
- Update to 1.19-1

	* Fixed a race condition at start of run with '--timeout=0'.
	* Added new option '-P, --data-preview'.
	* Added new option '-u, --unidirectional'.
	* Added new option '-X, --exit-on-error'.
	* Added new option '--ask' to ask for user confirmation.
	* Added new option '--cpass' to select passes during copying phase.
	* Added new option '--pause' to insert a pause between passes.
	* Removed option '-l, --logfile-size'.
	* Skip on the first error during the copying phase.
	* rescuebook.cc: Trimming done in one pass, may be run in reverse.
	* The splitting phase has been replaced by a scraping phase.
	* Changed long name of option '-n' to '--no-scrape'.
	* rescuebook.cc: Alternate direction of passes during retrying phase.
	* Show ATA model and serial number with '--ask' or '-vv' on Linux.
	* configure: Added new option '--enable-linux'.
	* New files linux.h linux.cc.
	* License changed to GPL version 2 or later.

* Mon Jul 21 2014 Lawrence Rogers <lrr@cert.org> 1.18.1-2
- Update to 1.18.1-2
	This patch currently adds the following options:

	--no-reverse-pass          do not switch direction for each pass
	--skip-on-first-err        start skipping on first error
	--trim-sequentially        don't trim small blocks first
	--split-sequentially       don't split large blocks first

	--no-reverse: This makes the second pass also go in the same direction as the first. This
	is for those who may ask for the option. But in my benchmark testing I can say there
	is no real benefit to turning off reverse.

	--skip-on-first-err: By default, ddrescue doesn't start skipping until 2 errors are
	encountered in a row. Sometimes the errors are spread out so that skipping does not
	happen very often if at all. This option will make ddrescue skip on the first error on the
	first pass forwards, and also on the second pass in reverse. If used with --no-reverse,
	the second forward pass skips on the second error like normal. Note that if used with
	the --reverse option then ddrescue will behave as normal and this option will not do
	anything. This option does best when setting a higher skip size, as when used with the
	default skip size it does not have a positive effect.

	--trim-sequentially: Normally ddrescue trims the smallest block first, which can cause
	unwanted head movement. This option makes it trim in order in one pass in the direction
	specified. My tests did not show any speed difference, but the small size of the test
	also did not have excessive head movement to begin with.

	--split-sequentially: Normally ddrescue splits the largest blocks first (which can
	cause a lot of unwanted head movement), and then when there are only small blocks of
	less than 7 sectors in size it will split sequentially. This option makes it split
	in order in one pass in the direction specified. In my benchmarking tests this helped
	slightly with overall recovery time, which is likely a result of drive read-ahead. This
	was even with a small test size, so it is possible that there could be more to gain on
	a full size recovery. Note that this speed increase would not normally be noticed due
	to the amount of time errors take to process, and is a very small increase overall. The
	biggest benefit is the head movement.

* Sat Jun 07 2014 Lawrence Rogers <lrr@cert.org> 1.18.1-1
- Update to 1.18.1
	* Version 1.18.1 released.
	* ddrescuelog.cc (do_logic_ops): Fixed 'or' and 'xor'.
	* Added new option '-H, --test-mode' to simulate read errors.
	* Added new option '-L, --loose-domain' to ddrescue and ddrescuelog.
	* Added new option '-N, --no-trim' to disable trimming of damaged areas.
	* Added new option '-O, --reopen-on-error'.
	* Added new options '-1, --log-rates', and '-2, --log-reads'.
	* Extended '-K, --skip-size' with maximum and disable values.
	* Changed long name of option '-r' to '--retry-passes'.
	* Changed short name of option '--generate-mode' to '-G'.
	* Default value of option '-l, --logfile-size' increased to 10000.
	* If interrupted, ddrescue terminates by raising the signal received.
	* rescuebook.cc (copy_non_tried): Do not mark skipped blocks as non-trimmed.
	  Try them in additional passes (before trimming).
	* rescuebook.cc: Limit the copying phase to 3 passes.
	* rescuebook.cc: Alternate direction of passes during copying phase.
	* rescuebook.cc: Smallest blocks are trimmed first.
	* rescuebook.cc (split_errors): Read largest first if logfile full.
	* Improved speed when using option '-m, --domain-logfile'.
	* io.cc (show_status): Show the current total run time.
	* rescuebook.cc: Show pass number and direction during copying.
	* rescuebook.cc (show_status): Show block pos instead of current_pos.
	* main.cc: Show "an unknown number of bytes" for unknown isize.
	* Added option '-B, --binary-prefixes' to ddrescuelog.
	* Added new option '-C, --complete-logfile' to ddrescuelog.
	* Added new option '-P, --compare-as-domain' to ddrescuelog.
	* Improved speed of logic operations in ddrescuelog.
	* rescuebook.cc (Rescuebook::do_rescue): Show warning when domain is smaller than logfile.
	* ddrescuelog.cc (do_show_status): Show logfile and domain extents when domain is smaller than logfile.
	* block.h: Class Block now forces the invariant by itself.
	* Code reorganization. New class 'Logfile'.
	* Added status message to rescue logfile.
	* Many improvements to documentation.
	* ddrescue.texinfo: Renamed to ddrescue.texi.

* Mon Jun 11 2012 Lawrence Rogers <lrr@cert.org> 1.17-1
- Update to 1.17
	* Version 1.17 released.
	* Added new option '-l, --logfile-size'.
	* Added new option '-w, --ignore-write-errors'.
	* Option '--fill' has been renamed to '--fill-mode'.
	* Option '--generate-logfile' has been renamed to '--generate-mode'.
	* Added option '--sector-size' as a synonym of '--block-size'.
	* Added option '--retries' as a synonym of '--max-retries'.
	* Added option '--size' as a synonym of '--max-size'.
	* rescuebook.cc: Trimming is now done from both edges of each
	  non-trimmed block. Largest blocks are trimmed first.
	* rescuebook.cc: Largest blocks are now split first until
	  logfile reaches '--logfile-size' entries.
	* logbook.cc (extend_sblock_vector, truncate_vector): Terminate
	  if truncation would discard finished blocks.
	* rescuebook.cc: Mark failed blocks with 1 sector as bad-sector.
	* logbook.cc (extend_sblock_vector): Remove last block of
	  logfile if it starts at isize and is not marked as finished.
	* io.cc (show_status,update_rates): Detect a jump back in time
	  and adjust status.
	* ddrescue.h (slow_read): Return false for the first 10 seconds.
	* io.cc (show_status) Leave cursor after message so that ^C does
	  not overwrite it.
	* main.cc: Do not require '--force' for generate mode.
	* ddrescue.h (Logbook::logfile_exists): Do not return false if
	  logfile exists but is empty.
	* Added new chapter 'Using ddrescue safely' to the manual.
	* Documented that 'direct disc access' only reads whole sectors.
	* configure: Options now accept a separate argument.
	* Makefile.in: Added new target 'install-bin'.

* Mon Jun 11 2012 Lawrence Rogers <lrr@cert.org> 1.16-1
- Update to 1.16
	* Version 1.16 released.
	* Added new option '-K, --skip-size'.
	* Added new option '-T, --timeout'.
	* Changed short name of option '--try-again' to '-A'.
	* Maximum skip size is now limited to 1% of infile size or 1 GiB
	  (whichever is smaller), rounded to the next multiple of sector
	  size.
	* Set current_pos to end of block when reading backwards.
	* The '-E, --max-error-rate' option now checks the rate of
	  actually failed reads, not the growth of error size.
	* The option '-v, --verbose' now increases verbosity if repeated.
	* Changed quote characters in messages as advised by GNU Standards.
	* configure: 'datadir' renamed to 'datarootdir'.
	* New files rational.h, rational.cc.

* Sun Jan 1 2012 Antonio Diaz Diaz <ant_diaz@teleline.es> 1.15-1
- Update to 1.15
	* Version 1.15 released.
	* Added new option `-a, --min-read-rate'.
	* Added new option `-I, --verify-input-size'.
	* Added new option `-x, --extend-outfile'.
	* main.cc: Verify that infile, outfile and logfile are all different.
	* Non-tried blocks are now read aligned to cluster-size sectors.
	* rescuebook.cc: Improved skip algorithm for the split pass.
	* main.cc: Removed spurious warning about `-D' ignored in fill mode.
	* ddrescue.texinfo: Improved description of algorithm.
	* logbook.cc (change_chunk_status): Return an adjust value (-1, 0, 1)
	  to keep "errors" updated without calling count_errors every time.
	* ddrescue.cc: Renamed to io.cc.
	* Added `ddrescuelog', a program for logfile manipulation.

* Mon Jan 10 2011 Antonio Diaz Diaz <ant_diaz@teleline.es> 1.14-1
- Update to 1.14.
        * Version 1.14 released.
        * Added new option `-R, --reverse'.
        * Added new option `-E, --max-error-rate'.
        * Extended syntax `--max-errors=+N' to specify new errors.
        * Changed short name of option `--retrim' to `-M'.
        * Removed spurious warning about `preallocation not available'.
        * Code reorganization. New class `Genbook'.

* Thu Nov 18 2010 Jussi Lehtola <jussilehtola@fedoraproject.org> - 1.13-1
- Update to 1.13.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Apr 22 2009 Ville Skyttä <ville.skytta@iki.fi> - 1.8-5
- Build with $RPM_OPT_FLAGS (#497152).

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Jul 16 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.8-3
- fix license tag

* Mon Feb 25 2008 Andreas Thienemann <athienem@redhat.com> - 1.8-2
- Fix info-page installation

* Mon Feb 25 2008 Andreas Thienemann <athienem@redhat.com> - 1.8-1
- Initial fedora release of GNU ddrescue
